<?php

namespace App\Nova\Resources\System\Settings\Location\Province;

use App\Models\System\Settings\Location\Province as ProvinceModel;
use App\Models\System\Settings\Location\Region;
use App\Nova\Resource;
use Laravel\Nova\Fields\ID;
use Laravel\Nova\Fields\Select;
use Laravel\Nova\Fields\Text;
use Laravel\Nova\Http\Requests\NovaRequest;

class Province extends Resource
{
    /**
     * The model the resource corresponds to.
     *
     * @var class-string<\App\Models\Resources\System\Settings\Location\Province\Province>
     */
    public static $model = ProvinceModel::class;

    /**
     * The single value that should be used to represent the resource when being displayed.
     *
     * @var string
     */
    public static $title = 'name';

    /**
     * The columns that should be searched.
     *
     * @var array
     */
    public static $search = [
        'id', 'name',
    ];

    /**
     * Get the displayable label of the resource.
     */
    public static function label(): string
    {
        return __('Provinces');
    }

    /**
     * Get the displayable singular label of the resource.
     */
    public static function singularLabel(): string
    {
        return __('Province');
    }

    /**
     * Get the fields displayed by the resource.
     */
    public function fields(NovaRequest $request): array
    {
        return [
            ID::make()->sortable(),

            Select::make(__('Region'), 'region')
                ->displayUsingLabels()
                ->searchable()
                ->options(Region::values())
                ->default(Region::AG)
                ->rules('required')
                ->sortable(),

            Text::make(__('Name'), 'name')
                ->rules('required', 'string', 'max:255')
                ->translatable()
                ->sortable(),
        ];
    }

    /**
     * Get the filters available for the resource.
     */
    public function filters(NovaRequest $request): array
    {
        return [
            new Filters\RegionFilter(),
        ];
    }
}
